
// VerifyBinToolDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "VerifyBinTool.h"
#include "VerifyBinToolDlg.h"
#include "DbgFunc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

typedef struct
{
    UCHAR iap_flag[8];                  /*8ֽiap־̶Ϊ"WCHNET",ಹ0*/
    UCHAR iap_len[4];                   /*8ֽiapļȣΪbinļ+512ֽ*/
    UCHAR iap_ckecksum[4];              /*4ֽڼ*/
    UCHAR resv[492];                    /*ֶΣ0*/
}iap_header;
// CVerifyBinToolDlg Ի

HWND AfxMainHwnd;                    //Ի


CVerifyBinToolDlg::CVerifyBinToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVerifyBinToolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVerifyBinToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVerifyBinToolDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CVerifyBinToolDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_CLEAR, &CVerifyBinToolDlg::OnBnClickedClear)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, &CVerifyBinToolDlg::OnBnClickedButtonBrowse)
END_MESSAGE_MAP()


// CVerifyBinToolDlg Ϣ
void CVerifyBinToolDlg::OnClose()
{
	OnOK();
	//return CDialog::OnClose();
}

BOOL CVerifyBinToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	AfxMainHwnd = this->GetSafeHwnd();
	return TRUE;  // ǽõؼ򷵻 TRUE
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CVerifyBinToolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CVerifyBinToolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVerifyBinToolDlg::OnBnClickedClear()
{
	GetDlgItem(IDC_EDIT_FILE)->SetWindowText("");
}

void CVerifyBinToolDlg::OnBnClickedButtonBrowse()
{
	OPENFILENAME OpenedFile = {0};                                 // Ҫ򿪵ļṹ
	CHAR FileName[MAX_PATH] = "";
	// .hexļ
	OpenedFile.lStructSize = sizeof(OpenedFile);                   // ṹΪļߴ
	OpenedFile.lpstrFile = FileName;                               // ȫ·ļ
	OpenedFile.nMaxFile = MAX_PATH;                                // ȫļ
	OpenedFile.lpstrFilter = "BIN File (*.bin)\0*.bin\0";          // ޶ļΪ.hex .bin
	
	GetOpenFileName(&OpenedFile);
	GetDlgItem(IDC_EDIT_FILE)->SetWindowText(FileName);
	((CEdit*)GetDlgItem(IDC_EDIT_FILE))->SetSel(-1);
	if(strlen(FileName)>0)
		DbgPrint("Choose Firmware:%s",FileName);
}

void CVerifyBinToolDlg::OnBnClickedOk()
{
	HANDLE  hFile = INVALID_HANDLE_VALUE;
	CHAR  szFile[MAX_PATH] = "";
	UCHAR *pSourFile = NULL,*pTotalFile = NULL;
	ULONG ulFileSize = 0,ulTotalLen = 0,ulReadLen = 0,ulWriteLen = 0,CheckSum32 = 0,i = 0;
	UCHAR szData[4] = "";

	GetDlgItem(IDC_EDIT_FILE)->GetWindowText(szFile,MAX_PATH);

	if(strlen(szFile) < 1)
	{
		DbgPrint("ѡĿļ!");
		goto _END;
	}
	
	hFile = CreateFile(szFile,GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

	ulFileSize = GetFileSize(hFile,NULL);

	if(ulFileSize < 1)
	{
		DbgPrint("ĿļЧ!");
		goto _END;
	}

	pSourFile = (UCHAR*)malloc(ulFileSize + 1);

	memset(pSourFile,0,ulFileSize + 1);

	pTotalFile = (UCHAR*)malloc(ulFileSize + 512 + 1);

	memset(pTotalFile,0,ulFileSize + 512 + 1);

	ulTotalLen = ulFileSize + 512;

	ReadFile(hFile,pSourFile,ulFileSize,&ulReadLen,NULL);

	if(ulReadLen != ulFileSize)
	{
		DbgPrint("Ŀļʧ!");
		goto _END;
	}
	
	memcpy(pTotalFile,"WCHNET",strlen("WCHNET"));
	pTotalFile[8] = (UCHAR)ulTotalLen;
	pTotalFile[9] = (UCHAR)(ulTotalLen>>8);
	pTotalFile[10] = (UCHAR)(ulTotalLen>>16);
	pTotalFile[11] = (UCHAR)(ulTotalLen>>24);
 
	while(1)
	{
		memset(szData,0,4);
		if((i+4) >=  ulFileSize)  
		{
			memcpy(szData,&pSourFile[i],ulFileSize-i);
			CheckSum32 += *(PULONG)szData;
			goto _CON;
		}
		else
		{
			memcpy(szData,&pSourFile[i],4);
			CheckSum32 += *(PULONG)szData;
		}	
		i += 4;
	}

_CON:

	pTotalFile[12] = (UCHAR)CheckSum32;
	pTotalFile[13] = (UCHAR)(CheckSum32>>8);
	pTotalFile[14] = (UCHAR)(CheckSum32>>16);
	pTotalFile[15] = (UCHAR)(CheckSum32>>24);

	memcpy(&pTotalFile[512],pSourFile,ulFileSize);

	if(hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	strcat(szFile,".bin");

	hFile = CreateFile(szFile,GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

	if(hFile == INVALID_HANDLE_VALUE)
	{
		DbgPrint("ļʧ!");
		goto _END;
	}

	WriteFile(hFile,pTotalFile,ulTotalLen,&ulWriteLen,NULL);

	if(ulWriteLen != ulTotalLen)
	{
		DbgPrint("дļʧ!");
		goto _END;
	}
	else
	{
		DbgPrint("ļɹ%s!",szFile);
	}

_END:
	if(hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	if(pSourFile != NULL)
	{
		free(pSourFile);
		pSourFile = NULL;
	}

	if(pTotalFile != NULL)
	{
		free(pTotalFile);
		pTotalFile = NULL;
	}
}